Ubuntu

Multiarchify tcl8.5

Reported by Wookey on 2013-02-11
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
tcl8.5 (Debian)
Fix Released
Unknown
tcl8.5 (Ubuntu)
Low
Dimitri John Ledkov
tcl8.6 (Ubuntu)
Low
Dimitri John Ledkov
tcltk-defaults (Ubuntu)
Low
Unassigned
tk8.5 (Debian)
Fix Released
Unknown
tk8.5 (Ubuntu)
Low
Colin Watson
tk8.6 (Ubuntu)
Low
Dimitri John Ledkov

Bug Description

TCL needs 'multiarching' so that it has co-installable libraries and config scripts for packages to cross-build with. e.g sqlite3, but in fact anything with tcl language bindings (45 packages build-dep on tcl8.5, and 65 on tcl-dev).

The attached patch provides such mutiarchification, by:

qEssentially the .so and .a libs, and the tclConfig.sh config script are all moved into multiarch directories in the existing tcl8.5-dev and a new tcl8.5-lib package for the runtime library. Both these packages are Multi-Arch: same and thus co-installable.

All the other files remain in the tcl8.5 package, although there may be arch-specific files in there which should move? That package is MA: foreign as tcl is able to run scripts in an arch-independent fashion.

This has been tested for armhf and arm64 cross-building and seems to work OK.

Wookey (wookey) wrote :

The attachment "tcl8.5_8.5.13-1ubuntu1-multiarchify-2.patch" of this bug report has been identified as being a patch in the form of a debdiff. The ubuntu-sponsors team has been subscribed to the bug report so that they can review and hopefully sponsor the debdiff. In the event that this is in fact not a patch you can resolve this situation by removing the tag 'patch' from the bug report and editing the attachment so that it is not flagged as a patch. Additionally, if you are member of the ubuntu-sponsors team please also unsubscribe the team from this bug report.

[This is an automated message performed by a Launchpad user owned by Brian Murray. Please contact him regarding any issues with the action taken in this bug report.]

tags: added: patch
Changed in tcl:
status: Unknown → New
Dimitri John Ledkov (xnox) wrote :

Inspecting the patch, it looks mostly fine.

The other piece of the puzzle is that tcltk-defaults should be then transitioned to be Architecture:any and I believe also have matching M-A: stanzas (?!), but I'll check about that. This patch got me thinking if we have arch-qualified provides or not =)))

Changed in tcl8.5 (Ubuntu):
assignee: nobody → Dmitrijs Ledkovs (xnox)
status: New → Confirmed
importance: Undecided → Low
Changed in tcl8.5 (Ubuntu):
status: Confirmed → Fix Committed
Steve Kowalik (stevenk) on 2013-03-12
Changed in tcl:
importance: Unknown → Undecided
Changed in tcltk-defaults (Ubuntu):
status: New → Fix Committed
Changed in tcl8.6 (Ubuntu):
status: New → Confirmed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package tcltk-defaults - 8.5.0-2ubuntu1

---------------
tcltk-defaults (8.5.0-2ubuntu1) raring; urgency=low

  * Add mutli-arch fields. (LP: #1122120)
 -- Dmitrijs Ledkovs <email address hidden> Tue, 12 Mar 2013 11:51:41 +0000

Changed in tcltk-defaults (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package tcl8.5 - 8.5.13-1ubuntu2

---------------
tcl8.5 (8.5.13-1ubuntu2) raring; urgency=low

  * Multiarchify package: split libs and tclConfig.sh into -lib
      package and use multiarch paths (LP: #1122120)
  * Fix failure to clean and build twice
 -- Wookey <email address hidden> Tue, 12 Mar 2013 10:59:49 +0000

Changed in tcl8.5 (Ubuntu):
status: Fix Committed → Fix Released
Changed in tcl8.6 (Ubuntu):
assignee: nobody → Dmitrijs Ledkovs (xnox)
importance: Undecided → Low
affects: tcl → hello (Ubuntu)
no longer affects: hello (Ubuntu)
Changed in tcl8.5 (Debian):
status: Unknown → New
Colin Watson (cjwatson) wrote :

It's a mistake to multiarch only one of Tcl and Tk and not the other - this causes confusion in some build systems (e.g. ruby1.8). I'll add tasks for Tk, including reopening the tcltk-defaults task.

Changed in tk8.5 (Ubuntu):
status: New → Confirmed
importance: Undecided → Low
assignee: nobody → Colin Watson (cjwatson)
Changed in tk8.6 (Ubuntu):
status: New → Confirmed
importance: Undecided → Low
Changed in tcltk-defaults (Ubuntu):
status: Fix Released → Triaged
Changed in tcl8.6 (Ubuntu):
status: Confirmed → Triaged
Changed in tk8.5 (Ubuntu):
status: Confirmed → Triaged
Changed in tk8.6 (Ubuntu):
status: Confirmed → Triaged
Changed in tcltk-defaults (Ubuntu):
importance: Undecided → Low
Colin Watson (cjwatson) on 2013-03-19
Changed in tk8.5 (Ubuntu):
status: Triaged → In Progress
Changed in tcltk-defaults (Ubuntu):
status: Triaged → In Progress
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package tk8.5 - 8.5.11-2ubuntu2

---------------
tk8.5 (8.5.11-2ubuntu2) raring; urgency=low

  * Cope with multiarch tcl8.5.
  * Convert to multiarch, splitting out libtk8.5.so.0 into a tk8.5-lib
    package and using multiarch paths (LP: #1122120).
 -- Colin Watson <email address hidden> Tue, 19 Mar 2013 12:17:55 +0000

Changed in tk8.5 (Ubuntu):
status: In Progress → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package tcltk-defaults - 8.5.0-2ubuntu3

---------------
tcltk-defaults (8.5.0-2ubuntu3) raring; urgency=low

  * Drop redundant tcl-dev -> tcl-lib dependency; the dependency on tcl here
    is enough.
  * Convert tk* to multiarch (LP: #1122120).
 -- Colin Watson <email address hidden> Tue, 19 Mar 2013 12:33:12 +0000

Changed in tcltk-defaults (Ubuntu):
status: In Progress → Fix Released
Changed in tk8.5 (Debian):
status: Unknown → New
Changed in tk8.6 (Ubuntu):
assignee: nobody → Dmitrijs Ledkovs (xnox)
Matthias Klose (doko) wrote :

now, the library is moved into the multiarch location, but nothing else. I think this can be done better. The goal should be to have a runnable embedded Tcl interpreter inside the tcl8.5-lib packages. This includes the shared library files. Packages like vim should be installable for the foreign architecture with keeping tcl8.5 installed for the native architecture.

Changed in tcl8.5 (Ubuntu):
status: Fix Released → Confirmed
Changed in tk8.5 (Ubuntu):
status: Fix Released → Confirmed

Matthias, any chance you could make this a separate bug? This bug
already has quite a few tasks and it's going to get quite cumbersome if
we keep reopening bits of it.

vim seems like a very tenuous use case, anyway. I can't think of a
reason I'd want to install it from a foreign architecture.

Matthias Klose (doko) wrote :

now continued in lp: #1164937

Colin:
> vim seems like a very tenuous use case, anyway. I can't think of a
> reason I'd want to install it from a foreign architecture.

vim was just used here as an example for an embedded interpreter. E.g. Installing the amd64 gdb on i386 with the embedded python interpreter to debug 64bit executables is a better use case. So please see vim just as an example.

Changed in tk8.6 (Ubuntu):
status: Triaged → Fix Released
Changed in tk8.5 (Ubuntu):
status: Confirmed → Fix Released
Changed in tk8.6 (Ubuntu):
status: Fix Released → Triaged
Changed in tcl8.5 (Ubuntu):
status: Confirmed → Fix Released
Changed in tcl8.5 (Debian):
status: New → Fix Committed
Changed in tk8.5 (Debian):
status: New → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package tcl8.6 - 8.6.0-1ubuntu1

---------------
tcl8.6 (8.6.0-1ubuntu1) saucy; urgency=low

  * Multiarchify package: split libs and tclConfig.sh into -lib
      package and use multiarch paths (LP: #1122120)
 -- Dmitrijs Ledkovs <email address hidden> Tue, 30 Jul 2013 15:44:35 +0100

Changed in tcl8.6 (Ubuntu):
status: Triaged → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package tk8.6 - 8.6.0-1ubuntu1

---------------
tk8.6 (8.6.0-1ubuntu1) saucy; urgency=low

  * Convert to multiarch, splitting out libtk8.6.so.0 into a tk8.6-lib
    package and using multiarch paths (LP: #1122120).
 -- Dmitrijs Ledkovs <email address hidden> Mon, 05 Aug 2013 12:13:19 +0100

Changed in tk8.6 (Ubuntu):
status: Triaged → Fix Released
Wookey (wookey) on 2013-09-25
Changed in tcl8.5 (Ubuntu):
status: Fix Released → Won't Fix
Colin Watson (cjwatson) on 2013-09-25
Changed in tcl8.5 (Ubuntu):
status: Won't Fix → Fix Released
Changed in tk8.5 (Debian):
status: Fix Committed → Fix Released
Changed in tcl8.5 (Debian):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.